//+------------------------------------------------------------------+
//|                                Export MarketInfo To CSV-file.mq4 |
//|                                   Copyright  2007, Serega Lykov |
//|                                       http://mtexperts.narod.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"

#property show_inputs

extern int delay = 1000;   //  ( )
extern int timeframe = 1;  // 1 = PERIOD_M1
                           // 5 = PERIOD_M5
                           // 15 = PERIOD_M15
                           // 30 = PERIOD_M30
                           // 60 = PERIOD_H1
                           // 240 = PERIOD_H4
                           // 1440 = PERIOD_D1
                           // 10080 = PERIOD_W1
                           // 43200 = PERIOD_MN1
                           // 0 =   
extern bool replace_data = false; // true -       
                                  // false -       
extern string file_name = "my_data"; //  CSV-,  

string script_link = "http://mtexperts.narod.ru/";
string script_name = " Export MarketInfo To CSV-file";

//    
void deinit()
  {
   Comment("");
  }

//+------------------------------------------------------------------+
//| "      CSV-"      |
//+------------------------------------------------------------------+
int start()
  {
   //  
   Comment(script_link,"\n",script_name);
   //  
   while(true)
     {
      //     
      int handle1 = FileOpenHistory("symbols.sel",FILE_BIN | FILE_READ);
      if(handle1 < 1)
        {
         Print(":  symbols.sel  ");
         return(false);
        }
      if(replace_data == false) int handle2 = FileOpen(file_name+".csv",FILE_CSV | FILE_READ | FILE_WRITE,',');
      else handle2 = FileOpen(file_name+".csv",FILE_CSV | FILE_WRITE,',');
      if(handle2 < 1)
        {
         Print(":  ",file_name,".csv  ");
         FileClose(handle1);
         return(false);
        }
      //  ,  
      if(replace_data == false) FileSeek(handle2,0,SEEK_END);
      int total = (FileSize(handle1)-4)/128;
      FileSeek(handle1,4,SEEK_SET);
      for(int i=0;i<total;i++)
        {
         string sym = FileReadString(handle1,12);
         double open = iOpen(sym,timeframe,0);
         double high = iHigh(sym,timeframe,0);
         double low = iLow(sym,timeframe,0);
         double close = iClose(sym,timeframe,0);
         double volume = iVolume(sym,timeframe,0);
         FileWrite(handle2,sym,open,high,low,close,volume,TimeToStr(TimeCurrent()));
//       FileWrite(handle2,sym,MarketInfo(sym,MODE_BID),MarketInfo(sym,MODE_ASK),TimeToStr(TimeCurrent()));
         FileSeek(handle1,116,SEEK_CUR);
        }
      //  
      FileClose(handle2);
      FileClose(handle1);
      if(IsStopped() == true) break;
      Sleep(delay);
     }
   Comment("");
   return(0);
  }

//+------------------------------------------------------------------+